From 981ab7067f7f68ede1e06e1519f0dcde62058531 Mon Sep 17 00:00:00 2001
From: Rob Jonson <rob@hobbyistsoftware.com>
Date: Sun, 18 Sep 2011 15:45:49 +0100
Subject: [PATCH 2/2] second half of the patch supporting json requests
 (making use of the central model in httprequests.lua)
 playlist.xml refactored, and drawing data from the
 central model (the output is entirely compatible with
 the old playlist.xml) playlist.json provides an
 alternative view of the same data

---
 share/Makefile.am                     |    1 +
 share/lua/http/requests/playlist.json |   38 ++++++++++++
 share/lua/http/requests/playlist.xml  |  106 ++++++++++++++++++--------------
 3 files changed, 99 insertions(+), 46 deletions(-)
 create mode 100644 share/lua/http/requests/playlist.json

diff --git a/share/Makefile.am b/share/Makefile.am
index d7b5dbd..f030eda 100644
--- a/share/Makefile.am
+++ b/share/Makefile.am
@@ -323,6 +323,7 @@ DIST_http_lua = \
 	lua/http/mobile_view.html \
 	lua/http/.hosts \
 	lua/http/requests/playlist.xml \
+	lua/http/requests/playlist.json \
 	lua/http/requests/README.txt \
 	lua/http/requests/playlist_jstree.xml \
 	lua/http/requests/browse.xml \
diff --git a/share/lua/http/requests/playlist.json b/share/lua/http/requests/playlist.json
new file mode 100644
index 0000000..832174e
--- /dev/null
+++ b/share/lua/http/requests/playlist.json
@@ -0,0 +1,38 @@
+<?vlc --[[
+vim:syntax=lua
+<!--  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - >
+<  playlist.json: VLC media player web interface 
+<  this should mirror the content of playlist.xml
+< - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - >
+<  Copyright (C) 2005-2006 the VideoLAN team
+<  $Id$
+< 
+<  Authors: Rob Jonson <rob -at- hobbyistsoftware -dot- com>
+< 
+<  This program is free software; you can redistribute it and/or modify
+<  it under the terms of the GNU General Public License as published by
+<  the Free Software Foundation; either version 2 of the License, or
+<  (at your option) any later version.
+< 
+<  This program is distributed in the hope that it will be useful,
+<  but WITHOUT ANY WARRANTY; without even the implied warranty of
+<  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+<  GNU General Public License for more details.
+< 
+<  You should have received a copy of the GNU General Public License
+<  along with this program; if not, write to the Free Software
+<  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
+< - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -->
+]] ?>
+<?vlc
+
+--package.loaded.httprequests = nil --uncomment to debug changes
+require "httprequests"
+
+httprequests.processcommands()
+
+print('{')
+httprequests.printTableAsJson(httprequests.playlisttable(),0)
+print('}')
+
+?>
diff --git a/share/lua/http/requests/playlist.xml b/share/lua/http/requests/playlist.xml
index 23fdb64..aa28fc4 100644
--- a/share/lua/http/requests/playlist.xml
+++ b/share/lua/http/requests/playlist.xml
@@ -8,17 +8,18 @@ vim:syntax=lua
 <  $Id$
 <
 <  Authors: Antoine Cellerier <dionoea -at- videolan -dot- org>
-<
+<  Authors: Rob Jonson <rob -at- hobbyistsoftware -dot- com>
+< 
 <  This program is free software; you can redistribute it and/or modify
 <  it under the terms of the GNU General Public License as published by
 <  the Free Software Foundation; either version 2 of the License, or
 <  (at your option) any later version.
-<
+< 
 <  This program is distributed in the hope that it will be useful,
 <  but WITHOUT ANY WARRANTY; without even the implied warranty of
 <  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 <  GNU General Public License for more details.
-<
+< 
 <  You should have received a copy of the GNU General Public License
 <  along with this program; if not, write to the Free Software
 <  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
@@ -26,53 +27,66 @@ vim:syntax=lua
 ]] ?>
 
 <?vlc
---[[
-function a(t,pre)
-  local pre = pre or ""
-  for k,v in pairs(t) do
-    vlc.msg.err(pre..tostring(k).." : "..tostring(v))
-    if type(v) == "table" then
-      a(v,pre.."  ")
+
+--package.loaded.httprequests = nil --uncomment to debug changes
+require "httprequests"
+
+local printleaf = function(item)
+	print ("\n<leaf")
+	
+	for k,v in pairs(item) do
+	
+		if (k~="type") then 
+			print(" "..k.."=\""..v.."\"")
+		end        
     end
-  end
+	
+	print ("/>")
 end
---]]
 
-function print_playlist(item)
-    if item.flags.disabled then return end
-    if(item.children) then
-        local name = vlc.strings.convert_xml_special_chars(item.name or "")
-        print('<node id="' ..tostring(item.id).. '" name="' ..tostring(name).. '" ro="' ..(item.flags.ro and "ro" or "rw").. '">')
-        for _, child in ipairs(item.children) do
-            print_playlist(child)
-        end
-        print('</node>')
-    else
-        local name, path = vlc.strings.convert_xml_special_chars(item.name or "", item.path or "")
-        local current_item = vlc.input.item()
-        local current = ""
-        -- Is the item the one currently played
-        if(current_item ~= nil) then
-            if(vlc.input.item().uri(current_item) == path) then
-                current = 'current="current"'
-            end
-        end
-        print('<leaf id="' ..tostring(item.id).. '" uri="' ..tostring(path).. '" name="' ..name.. '" ro="' ..(item.flags.ro and "ro" or "rw").. '" duration ="' ..math.floor(item.duration).. '" ' ..current.. ' />')
+local printnode = function(item)
+	local children=NULL
+	
+	print ("\n<node")
+	
+	for k,v in pairs(item) do
+	
+		if (k=="type") then 
+			
+		elseif (k=="children") then 
+			children=v._array
+		else
+			print(" "..k.."=\""..v.."\"")
+		end        
     end
+	
+	print (">")
+	
+	return children
 end
 
-local p
-if _GET["search"] then
-  if _GET["search"] ~= "" then
-    _G.search_key = _GET["search"]
-  else
-    _G.search_key = nil
-  end
-  local key = vlc.strings.decode_uri(_GET["search"])
-  p = vlc.playlist.search(key)
-else
-  p = vlc.playlist.get()
+printitem = function(item)
+	local children=NULL
+	
+	if item.type=="node" then
+		children=printnode(item)
+		if (children) then
+			for i,v in ipairs(children) do
+				printitem(v)
+			end
+		end
+		print ("</node>")
+	else
+		printleaf(item)
+	end
+
 end
---a(p) --Uncomment to debug
-print_playlist(p)
-?>
+
+httprequests.processcommands()
+
+local pt=httprequests.playlisttable()
+
+printitem(pt)
+
+
+?>
\ No newline at end of file
-- 
1.7.5

